# Functions

Atfinity defines some useful, additional Jinja functions when working with ADX:

| Name                                                             | Description                                                                                                                                                                                        |
| ---------------------------------------------------------------- | -------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `render_markdown`                                                | Renders a string to markdown. Note that only basic formatting, not tables, is supported.                                                                                                           |
| `json_loads`                                                     | Converts a given string representing JSON to a Python dictionary, so you can easily process the result with Jinja.                                                                                 |
| `json_dumps`                                                     | Converts a Python object to a JSON string.                                                                                                                                                         |
| `translate_string`                                               | See [Custom Translations](/document-xml-adx/jinja-templating/custom-translations.md).                                                                                                              |
| `format_date(date, date_format=None)`                            | Formats a date value. Optionally accepts a format string. Uses the document language. Also available as a [filter](/document-xml-adx/jinja-templating/jinja-filters.md).                           |
| `format_date_speaking(date)`                                     | Formats a date in a human-readable format (`D. MMMM YYYY`). Uses the document language. Also available as a [filter](/document-xml-adx/jinja-templating/jinja-filters.md).                         |
| `format_date_time(datetime, date_format=None, time_format=None)` | Formats a datetime value. Optionally accepts separate date and time format strings. Uses the document language. Also available as a [filter](/document-xml-adx/jinja-templating/jinja-filters.md). |
| `format_date_time_speaking(datetime)`                            | Formats a datetime in a human-readable format. Uses the document language. Also available as a [filter](/document-xml-adx/jinja-templating/jinja-filters.md).                                      |
| `is_known(value)`                                                | Returns `True` if the value is not `None`. Also available as a [filter](/document-xml-adx/jinja-templating/jinja-filters.md).                                                                      |
| `is_unknown(value)`                                              | Returns `True` if the value is `None`. Also available as a [filter](/document-xml-adx/jinja-templating/jinja-filters.md).                                                                          |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.atfinity.io/document-xml-adx/jinja-templating/functions.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
